var comp = 
{
	mixins:[LIST],
	props:["entity"],
	data()
	{
		return {
			fields:
			{
				name:"Name",
				type:"Type",
				unit:"Qty",
				tag:"Tag",
				drawing:"Drawing",
			},
		}
	},
	watch:
	{
		entity:
		{
			deep:true,
			handler(val)
			{
				this.requestFetch();
			}
		}
	},
	methods: 
	{
		async onLoad(list_in)
		{
			var path = "./db/quote.php";
			var req = {}
           
            var input = list_in;
			if(!UTIL.Empty(this.entity))
			{
				req.action="get_bom";
				input.parent_id = this.entity.id;
				input.parent_type = this.entity.type;
				input.unit = this.entity.unit||1;
			}
            
			req.input =  input;

            var res =  await UTIL.apiCall(path,req);
			this.rows = res.data;
		},
		onSelect(val)
		{
			this.$emit("onSelect",val)
		},
		async onAdd(row)
        {
            var heading = "Quote Details";
            var sub = 
            {
                comp : "p-quote-bom-link",
                callback:()=> this.requestFetch(),
                props :
                {
                    value:row||{},
                }
            };

            this.$root.popup.show(heading,sub);
        },
		async onSave(val)
		{
			var path = "./db/assembly.php";
			var req = 
            {
                action:"save",
                input: 
                {
                    data:val
                }
            }

            var res =  await UTIL.apiCall(path,req, true);

			if(!UTIL.Empty(res)) this.$root.popup.close(true);
		},
    },
}