var comp = 
{
	props:["value","fields","button_label","cls","readonly"],
	watch:
	{
		form_output:
		{
			deep:true,
			handler(nv)
            {
				this.$emit("input",nv)
            }
		},
		value:
		{
			deep:true,
			handler(nv,ov)
            {
				if(!UTIL.isEqual(nv,ov))
				{
					this.setDefaults();
				}
				
				this.$emit("onChanged",nv)
            }
		},
		
	},
    created()
    {
		this.setDefaults();
	},
    data()
    {
		return {
			form_output:{},
			email_timer:null,
			email_value:"",
		}
	},
    methods:
    {
		setDefaults()
		{
			this.form_output =  this.value;

			for(var k in this.fields)
			{
				var field = this.fields[k]||{};
				field.type = field.type||"text"
				switch (field.type) 
				{
					case "number": 
					if(!this.form_output[k]) this.form_output[k] = field.default||0;
					this.form_output[k] = this.toNumberCal(field,this.form_output[k])
					break;
					case "date": this.form_output[k] = UTIL.getDateString(field.default);
					break;
				
					default:break;
				}
			}
		},
		checkRequired()
		{
			for(var k in this.meta)
			{
				var field = this.meta[k];
				var row_data = this.form_output[k];

				if(!row_data && field.required)
				{
					this.$root.popup.prompt("Require Fields not met","The field: "+field.label+" is required")
					return;
				}
			}
			this.$emit('onClick',this.form_output)
		},
		toNumber(field,val)
		{
			var res = val;
			
			if(Number(val))
			{
				var cur = field.currency;
				var pre = field.pre;
				var post = field.post;
				var places = field.places;
				if(Number(places)) res = val.toFixed(places)
				if(cur)	res =cur + " " + val.toFixed(2);
				if(pre)	res =pre + " " + val;
				if(post) res =res + " " + post;
			}
			return res;
		},
		toNumberCal(field,val)
		{
			var res = Number(val);
			
			if(res)
			{

				var places = Number(field.places);
				if(places)
				{
					var factor = Math.pow(10, places);
					res = Math.round(res * factor) / factor;
				}
			}
			return res;
		},
		validateEmail(val,field) 
		{
			if(!val)
			{
				if(UTIL.isFunc(this.email_timer?.cancel)) this.email_timer.cancel();
				field.has_error =false;
			}
			else
			{
				if(val!=this.email_value)
				{
					if(UTIL.isFunc(this.email_timer?.cancel)) this.email_timer.cancel();
					this.email_value = val;
				}
				this.email_timer = setTimeout(()=>
				{
					var mailformat = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/
					field.has_error = !(mailformat).test(val)
				},300)
			}
			
		},
		onSelect(field,row)
		{
			var f = field.onSelect;
			if(UTIL.isFunc(f))f(row);
		}
    },
}